// Connect.h : Declaration of the CConnect

#pragma once
#include "resource.h"       // main symbols

using namespace Office;
using namespace AddInDesignerObjects;

static _ATL_FUNC_INFO Event1Info1 = { CC_CDECL, VT_EMPTY, 1, { VT_DISPATCH } };

// CConnect
class ATL_NO_VTABLE CConnect : 
	public CComObjectRootEx<CComSingleThreadModel>
	, public CComCoClass<CConnect, &CLSID_Connect>
	, public IDispatchImpl<ICallbackInterface, &__uuidof(ICallbackInterface), &__uuidof(MyAddin1Lib), 1, 0>
	, public IDispatchImpl<_IDTExtensibility2, &__uuidof(_IDTExtensibility2), &__uuidof(__AddInDesignerObjects), 1, 0>
	, public IDispatchImpl<IRibbonExtensibility, &__uuidof(IRibbonExtensibility), &__uuidof(__Office), 12, 0>
	, public IDispEventSimpleImpl<1, CConnect, &__uuidof(Visio::EApplication)>
{
public:
	CConnect()
	{
	}

	DECLARE_REGISTRY_RESOURCEID(IDR_ADDIN)
	DECLARE_NOT_AGGREGATABLE(CConnect)

	BEGIN_COM_MAP(CConnect)
		COM_INTERFACE_ENTRY2(IDispatch, ICallbackInterface)
		COM_INTERFACE_ENTRY(IDTExtensibility2)
		COM_INTERFACE_ENTRY(IRibbonExtensibility)
		COM_INTERFACE_ENTRY(ICallbackInterface)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:
	//IDTExtensibility2 implementation:
	STDMETHOD(OnConnection)(IDispatch * Application, ext_ConnectMode ConnectMode, IDispatch *AddInInst, SAFEARRAY **custom);
	STDMETHOD(OnDisconnection)(ext_DisconnectMode RemoveMode, SAFEARRAY **custom );
	STDMETHOD(OnAddInsUpdate)(SAFEARRAY **custom );
	STDMETHOD(OnStartupComplete)(SAFEARRAY **custom );
	STDMETHOD(OnBeginShutdown)(SAFEARRAY **custom );

	//IRibbonExtensibility implementation:
	STDMETHOD(GetCustomUI)(BSTR RibbonID, BSTR * RibbonXml);

	STDMETHOD(ButtonClicked)(IDispatch * RibbonControl)
	{ 
		MessageBoxW(NULL,L"The button was clicked!", L"Message from ExampleATLAddIn", MB_OK | MB_ICONINFORMATION); 
		return S_OK; 
	}

    // this function provides us with IRibbonUI object, called when XML is loaded
    STDMETHOD(OnLoad)(IDispatch* disp)
    {
		disp->QueryInterface(__uuidof(Office::IRibbonUI), (void**)&m_pRibbonUI);
		return S_OK;
    }

    // callback for the tab visibility, return if our tab shall be visible
    STDMETHOD(IsMyTabVisible)(IDispatch* pControl, VARIANT_BOOL* pResult)
    {
		CComPtr<Visio::IVDocument> active_doc;
		m_pApplication->get_ActiveDocument(&active_doc);
        
		if (active_doc == NULL)
		{
			*pResult = VARIANT_FALSE;
		}
		else
		{
			CComPtr<Visio::IVShape> doc_shape;
			active_doc->get_DocumentSheet(&doc_shape);

			doc_shape->get_CellExists(CComBSTR(L"User.IsMyDoc"), VARIANT_FALSE, pResult);
		}

        return S_OK;
    }

	void __stdcall OnDocumentCreated(Visio::IVDocument* doc)
	{
		m_pRibbonUI->Invalidate();
	}

	void __stdcall OnDocumentOpened(Visio::IVDocument* doc)
	{
		m_pRibbonUI->Invalidate();
	}

	void __stdcall OnDocumentBeforeClose(Visio::IVDocument* doc)
	{
		m_pRibbonUI->Invalidate();
	}

	void __stdcall OnWindowActivated(Visio::IVWindow* wnd)
	{
		m_pRibbonUI->Invalidate();
	}

	BEGIN_SINK_MAP(CConnect)
		SINK_ENTRY_INFO(1, __uuidof(Visio::EApplication), 0x00000001, OnDocumentCreated, &Event1Info1)
		SINK_ENTRY_INFO(1, __uuidof(Visio::EApplication), 0x00000002, OnDocumentCreated, &Event1Info1)
		SINK_ENTRY_INFO(1, __uuidof(Visio::EApplication), 0x00004002, OnDocumentBeforeClose, &Event1Info1)
		SINK_ENTRY_INFO(1, __uuidof(Visio::EApplication), 0x00001080, OnWindowActivated, &Event1Info1)
	END_SINK_MAP()

	CComPtr<Visio::IVApplication>	m_pApplication;
	CComPtr<IDispatch>		m_pAddInInstance;
	CComPtr<Office::IRibbonUI>		m_pRibbonUI;
};

OBJECT_ENTRY_AUTO(__uuidof(Connect), CConnect)
